SystemOrganization addCategory: #'GT-Chatter'!
SystemOrganization addCategory: 'GT-Chatter-Examples'!
SystemOrganization addCategory: 'GT-Chatter-Integration'!
SystemOrganization addCategory: 'GT-Chatter-InternalAnnouncements'!
SystemOrganization addCategory: 'GT-Chatter-Model'!
SystemOrganization addCategory: 'GT-Chatter-RemoteAnnouncements'!
SystemOrganization addCategory: 'GT-Chatter-Tests'!
SystemOrganization addCategory: 'GT-Chatter-Theme'!
SystemOrganization addCategory: 'GT-Chatter-UI'!

GLMBrick subclass: #GTCSelectionInMethodMessageBrick
	instanceVariableNames: 'labelBrick browseBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTCSelectionInMethodMessageBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/24/2015 14:50'!
acceptReceivedMessage: aGTReceivedMessage 
	self theme chatterWidgetThemer receivedSourceCodePointerStyleFor: self.! !

!GTCSelectionInMethodMessageBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/24/2015 15:32'!
acceptSentMessage: aGTSentMessage 
	self theme chatterWidgetThemer 
			sentSourceCodePointerStyleFor: self;
			sentSourceCodePointerLabelStyleFor: self labelBrick! !

!GTCSelectionInMethodMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 14:07'!
browseBrick: aBrick
	browseBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	browseBrick := aBrick.
	self theme chatterWidgetThemer sourceCodePointerBrowseButtonStyleFor: browseBrick.
	browseBrick addUpAction: [ self browseMethod ].
	self addBrickBack: aBrick.! !

!GTCSelectionInMethodMessageBrick methodsFor: 'protocol' stamp: 'JurajKubelka 1/20/2015 14:12'!
browseMethod
	^ self message ifNotNil: [ :aMessage | aMessage ring browse ]! !

!GTCSelectionInMethodMessageBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 13:48'!
initialize
	super initialize.
	self theme chatterWidgetThemer sourceCodePointerStyleFor: self.
	self labelBrick: self newLabelBrick.
	self browseBrick: self newBrowseBrick.
! !

!GTCSelectionInMethodMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 14:13'!
labelBrick
	^ labelBrick! !

!GTCSelectionInMethodMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 14:09'!
labelBrick: aBrick
	labelBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	labelBrick := aBrick.
	self theme chatterWidgetThemer sourceCodePointerLabelStyleFor: labelBrick.
	self addBrickBack: aBrick.! !

!GTCSelectionInMethodMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 12:51'!
labelString
	^ self message ring asString! !

!GTCSelectionInMethodMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 12:23'!
message
	^ self data! !

!GTCSelectionInMethodMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 12:51'!
message: aSelectionInMethodMessage
	self message = aSelectionInMethodMessage ifTrue: [ ^ self ].
	self data: aSelectionInMethodMessage.
	self labelBrick text: self labelString.
	self changed.! !

!GTCSelectionInMethodMessageBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/20/2015 14:04'!
newBrowseBrick
	^ GLMActionButtonBrick new! !

!GTCSelectionInMethodMessageBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/20/2015 14:04'!
newLabelBrick
	^ GLMLabelBrick new! !

GTCSelectionInMethodMessageBrick subclass: #GTCStackTraceBrick
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTCStackTraceBrick methodsFor: 'actions' stamp: 'JurajKubelka 1/23/2015 12:51'!
browseMethod
	^ self message ifNotNil: [ :aMessage | aMessage materialize ]! !

!GTCStackTraceBrick methodsFor: 'actions' stamp: 'JurajKubelka 1/23/2015 13:12'!
labelString
	^ self message title ifNil: [ 'Click to debug stack trace' ]! !

GLMBrick subclass: #GTCTextMessageBrick
	instanceVariableNames: 'editingAreaBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTCTextMessageBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/24/2015 14:59'!
acceptReceivedMessage: aMessage
	self theme chatterWidgetThemer 
			receivedTextMessageStyleFor: self;
			receivedTextMessageEditingAreaStyleFor: self editingAreaBrick.! !

!GTCTextMessageBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/24/2015 15:01'!
acceptSentMessage: aMessage
	self theme chatterWidgetThemer 
			sentTextMessageStyleFor: self;
			sentTextMessageEditingAreaStyleFor: self editingAreaBrick.! !

!GTCTextMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 14:22'!
editingAreaBrick
	^ editingAreaBrick! !

!GTCTextMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:57'!
editingAreaBrick: aMorph
	|brick|
	editingAreaBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	editingAreaBrick := aMorph.
	self theme chatterWidgetThemer textMessageEditingAreaStyleFor: editingAreaBrick.
	
	"we receive a Morph and need to manually convert it to brick,
	to allow its container shrink vertically to fit height of the rubric"
	brick := aMorph asBrick.
	brick layout vShrinkWrap.
	
	self addBrickBack: brick.! !

!GTCTextMessageBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 13:44'!
initialize
	super initialize.
	self theme chatterWidgetThemer textMessageStyleFor: self.
	self editingAreaBrick: self newEditingAreaBrick.! !

!GTCTextMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 13:05'!
message
	^ self data! !

!GTCTextMessageBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 10:33'!
message: aTextMessage
	self data: aTextMessage.
	self editingAreaBrick setTextWith: aTextMessage message asText.! !

!GTCTextMessageBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/15/2015 14:23'!
newEditingAreaBrick
	^ RubEditingArea new! !

GLMBrick subclass: #GTConversationBrick
	instanceVariableNames: 'listAdaptor listBrick inputBrick onlineUsersBrick chatterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:12'!
chatterModel: aGTChatter 
	chatterModel := aGTChatter! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/21/2015 18:35'!
conversation: aConversation
	self data: aConversation.
	self recipientBrickOn: aConversation.
	self listAdaptor on: aConversation messages.
	self invalidate.
	self inputBrick data: aConversation.! !

!GTConversationBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 13:02'!
initialize
	super initialize.
	self theme chatterWidgetThemer conversationStyleFor: self.
! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 15:50'!
inputBrick
	^ inputBrick ifNil: [ 
			inputBrick := self newInputBrick.
			self addBrickBack: inputBrick.
			inputBrick ]! !

!GTConversationBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 1/22/2015 21:00'!
invalidate
	self listBrick invalidate.
	self brickRoot doLayout.
	self listBrick scrollToBottom.
	self brickRoot changed.! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 12:50'!
listAdaptor
	^ listAdaptor ifNil: [ 
		listAdaptor := GTRowBrickAdaptor new
								on: #();
								owner: self;
								modelAccessor: #setupBrick:message:
								yourself ]! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 19:41'!
listBrick
	^ listBrick ifNil: [ 
			listBrick := GLMScrollListBrick new adaptor: self listAdaptor; yourself.
			self theme chatterWidgetThemer messagesScrollListStyleFor: listBrick.
			self addBrickBack: listBrick.
			listBrick ]! !

!GTConversationBrick methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/21/2015 18:46'!
messageAdded: aGTMessageAdded 
	self invalidate! !

!GTConversationBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/13/2015 10:37'!
newInputBrick
	^ GTMessageInputFieldBrick new! !

!GTConversationBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/15/2015 19:33'!
newMessageRowBrick
	^ self newRowBrick! !

!GTConversationBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/14/2015 12:39'!
newOnlineUsersDropListBrick
	^ GTOnlineUsersDropListBrick new.! !

!GTConversationBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/14/2015 12:38'!
newRowBrick
	^ GTMessageRowBrick new.! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:55'!
onlineRecipientBrickOn: aConversation
	"add drop down list with online users"
	self onlineUsersBrick: self newOnlineUsersDropListBrick.
	self onlineUsersBrick conversation: aConversation.
	! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 12:44'!
onlineUsersBrick
	^ onlineUsersBrick! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:24'!
onlineUsersBrick: aBrick
	self onlineUsersBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	onlineUsersBrick := aBrick.
	onlineUsersBrick chatterModel: chatterModel.
	self addBrick: aBrick before: self listBrick.
	self doLayout; changed.! !

!GTConversationBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 08:37'!
recipientBrickOn: aConversation
	aConversation isNewConversation 
		ifTrue: [ self onlineRecipientBrickOn: aConversation ]! !

!GTConversationBrick methodsFor: 'protocol' stamp: 'JurajKubelka 1/15/2015 19:31'!
setupBrick: aGTMessageRowBrickOrNil message: aGTMessage 
	^ aGTMessage updateBrick: aGTMessageRowBrickOrNil factory: self! !

GLMBrick subclass: #GTConversationsAndMessagesBrick
	instanceVariableNames: 'conversationsBrick conversationBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTConversationsAndMessagesBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/14/2015 12:18'!
acceptConversationSelected: aGTConversationSelected 
	self conversationBrick: self newConversationBrick.
	self conversationBrick conversation: aGTConversationSelected conversation.
	self doLayout.
	self changed.! !

!GTConversationsAndMessagesBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/14/2015 12:19'!
acceptMessageAdded: aGTMessageAdded 
	^ self conversationBrick messageAdded: aGTMessageAdded ! !

!GTConversationsAndMessagesBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:06'!
chatterModel 
	^ self data! !

!GTConversationsAndMessagesBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:06'!
chatterModel: aGTChatter 
	self data: aGTChatter.
	self conversationsBrick chatterModel: aGTChatter.! !

!GTConversationsAndMessagesBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 12:24'!
conversationBrick
	^ conversationBrick! !

!GTConversationsAndMessagesBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:07'!
conversationBrick: aBrick
	conversationBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	conversationBrick := aBrick.
	conversationBrick chatterModel: self chatterModel.
	self addBrickBack: aBrick.! !

!GTConversationsAndMessagesBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 11:54'!
conversationsBrick
	^ conversationsBrick! !

!GTConversationsAndMessagesBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:00'!
conversationsBrick: aBrick
	conversationsBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	conversationsBrick := aBrick.
	conversationsBrick selectedConversationProcessor: self.
	self addBrickBack: aBrick.! !

!GTConversationsAndMessagesBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 12:54'!
initialize
	super initialize.
	self theme chatterWidgetThemer conversationsAndMessagesStyleFor: self.
	self conversationsBrick: self newConversationsBrick.
	self conversationBrick: self newConversationBrick.! !

!GTConversationsAndMessagesBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/14/2015 11:53'!
newConversationBrick
	^ GTConversationBrick new! !

!GTConversationsAndMessagesBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/14/2015 11:49'!
newConversationsBrick
	^ GTConversationsBrick new! !

GLMBrick subclass: #GTConversationsBrick
	instanceVariableNames: 'listAdaptor listBrick lastCheckedRowBrick lastSelectedConversation conversationButton selectedConversationProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTConversationsBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:08'!
chatterModel: aGTChatter 
	self data ifNotNil: [ self unsubscribeFromConversations ].
	self data: aGTChatter.
	self subscribeOnConversations.
	self listAdaptor on: self conversations.
	self listBrick invalidate.! !

!GTConversationsBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/12/2015 15:00'!
conversationAdded: aGTConversationAdded
	self listBrick invalidate.! !

!GTConversationsBrick methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/21/2015 18:36'!
conversationSelected: aGTConversationSelected
	lastSelectedConversation = aGTConversationSelected conversation ifTrue: [ ^ self ].
	lastCheckedRowBrick ifNotNil: [ :brick | brick uncheck ].
	lastCheckedRowBrick := aGTConversationSelected widget.
	lastSelectedConversation := aGTConversationSelected conversation.
	aGTConversationSelected widget check.
	self passEvent: aGTConversationSelected! !

!GTConversationsBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:07'!
conversations
	^ self data conversations! !

!GTConversationsBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:10'!
createConversationButtonBrick: aBrick
	conversationButton ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	conversationButton := aBrick.
	self theme chatterWidgetThemer createConversationButtonStyleFor: aBrick.
	conversationButton addUpAction: [ self createNewConversation ].
	self addBrickBack: conversationButton.! !

!GTConversationsBrick methodsFor: 'private' stamp: 'JurajKubelka 1/14/2015 11:11'!
createNewConversation
	^ self conversations addNewConversation! !

!GTConversationsBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 12:59'!
initialize
	super initialize.
	self theme chatterWidgetThemer conversationsStyleFor: self.
	self createConversationButtonBrick: self newCreateConversationButtonBrick.! !

!GTConversationsBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 12:50'!
listAdaptor
	^ listAdaptor ifNil: [ 
		listAdaptor := GTRowBrickAdaptor new
								on: #();
								owner: self;
								modelAccessor: #setupBrick:conversation:
								yourself ]! !

!GTConversationsBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 19:41'!
listBrick
	^ listBrick ifNil: [ 
			listBrick := GLMScrollListBrick new adaptor: self listAdaptor; yourself.
			self theme chatterWidgetThemer conversationsScrollListStyleFor: listBrick. 
			self addBrickBack: listBrick.
			listBrick ]! !

!GTConversationsBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/14/2015 12:16'!
messageAdded: aGTMessageAdded
	lastCheckedRowBrick ifNotNil: [ :aBrick |
		aBrick conversation = aGTMessageAdded conversation 
			ifTrue: [ self passEvent: aGTMessageAdded ] ]! !

!GTConversationsBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/14/2015 11:08'!
newCreateConversationButtonBrick
	^ GLMActionButtonBrick new! !

!GTConversationsBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/7/2015 15:39'!
newRowBrick
	| brick |
	brick := GTConversationRowBrick new.
	brick announcer weak 
		subscribe: GTConversationSelected 
		send: #conversationSelected: to: self.
	^ brick! !

!GTConversationsBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/14/2015 12:16'!
passEvent: aGTAnnouncement 
	selectedConversationProcessor 
		ifNotNil: [ :aProcessor | aGTAnnouncement visit: aProcessor ]
		ifNil: [ 	self doLayout; changed. ]! !

!GTConversationsBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/14/2015 12:10'!
passSelectedConversation: aGTConversationSelected 
	selectedConversationProcessor 
		ifNotNil: [ :aProcessor | aProcessor conversationSelected: aGTConversationSelected ]
		ifNil: [ 	self doLayout; changed. ]! !

!GTConversationsBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 12:08'!
selectedConversationProcessor: aBrick
	selectedConversationProcessor := aBrick! !

!GTConversationsBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/15/2015 18:49'!
setupBrick: aGTConversationRowBrickOrNil conversation: aGTConversation 
	| aBrick |
	aBrick := aGTConversation updateBrick: aGTConversationRowBrickOrNil factory: self.
	
	lastSelectedConversation = aGTConversation 
		ifTrue: [ 
			lastCheckedRowBrick := aBrick. 
			aBrick check ]
		ifFalse: [ aBrick uncheck ].
	^ aBrick

! !

!GTConversationsBrick methodsFor: 'private' stamp: 'JurajKubelka 1/12/2015 13:01'!
subscribeOnConversations
	self conversations announcer
				subscribe: GTConversationAdded send: #conversationAdded: to: self;
				subscribe: GTMessageAdded send: #messageAdded: to: self.! !

!GTConversationsBrick methodsFor: 'private' stamp: 'JurajKubelka 1/12/2015 13:00'!
unsubscribeFromConversations
	self conversations announcer unsubscribe: self! !

GLMBrick subclass: #GTMessageInputFieldBrick
	instanceVariableNames: 'textBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTMessageInputFieldBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/19/2015 17:29'!
acceptedText: aRubTextAccepted 
	aRubTextAccepted text asString trimBoth isEmpty ifTrue: [ ^ self ].
	self announcer 
				announce: (GTSendTextMessage new 
								widget: aRubTextAccepted morph;
								conversation: self conversation;
								yourself).
	aRubTextAccepted morph setText: ''.! !

!GTMessageInputFieldBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:15'!
announcer
	^ self data 
			ifNil: [ Announcer new ]
			ifNotNil: [ :aData | aData announcer ]! !

!GTMessageInputFieldBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:41'!
conversation
	^ self data! !

!GTMessageInputFieldBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 15:51'!
initialize
	super initialize.
	self theme chatterWidgetThemer textMessageInputFieldStyleFor: self.
	self textBrick: self newTextBrick.! !

!GTMessageInputFieldBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/13/2015 10:32'!
newTextBrick
	^ RubScrolledTextMorph new! !

!GTMessageInputFieldBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 10:31'!
textBrick
	^ textBrick! !

!GTMessageInputFieldBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 22:08'!
textBrick: aRubScrolledTextMorph
	self textBrick ifNotNil: [ :anOldBrick | 
				anOldBrick announcer unsubscribe: self. 
				self removeBrick: anOldBrick ].
	textBrick := aRubScrolledTextMorph.
	self theme chatterWidgetThemer scrolledTextMorphStyleFor: textBrick.
	self addBrickBack: textBrick.
	self textBrick 
			bindKeyCombination: Character cr asKeyCombination 
			toAction: [ self textBrick acceptContents ].
	(self textBrick announcer subscribe: RubTextAccepted send: #acceptedText: to: self) 
		subscriber: self.! !

!GTMessageInputFieldBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 16:12'!
totalTextHeight
	^ self textBrick paragraph totalTextHeight! !

GLMBrick subclass: #GTMessageRowBrick
	instanceVariableNames: 'messageBrick blankBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTMessageRowBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/20/2015 14:31'!
acceptReceivedMessage: aMessage
	self addBrickBack: self messageBrick.
	self addBrickBack: self blankBrick.
! !

!GTMessageRowBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/20/2015 14:31'!
acceptSentMessage: aMessage
	self addBrickBack: self blankBrick.
	self addBrickBack: self messageBrick.! !

!GTMessageRowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/21/2015 17:49'!
blankBrick
	^ blankBrick ifNil: [
		blankBrick := GLMBrick new.
		blankBrick height: 0.
		"blank space must fill the rest of my width. It depends on messageBrick's percent width"
		blankBrick layoutProperties horizontalPercent: 5.
		blankBrick ]! !

!GTMessageRowBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 13:39'!
initialize
	super initialize.
	self theme chatterWidgetThemer messageRowStyleFor: self.! !

!GTMessageRowBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 18:35'!
message
	^ self data! !

!GTMessageRowBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:44'!
message: aSentOrReceivedMessage
	"for performance we reuse views in the list, instead of creating a new one.
	this method updates me and my subviews"
	
	"much easier to remove everything and add subviews back instead of changing order manually"
	self message = aSentOrReceivedMessage ifTrue: [ ^ self ].
	self data: aSentOrReceivedMessage.
	self removeAllBricks.
	messageBrick := aSentOrReceivedMessage contents asMessageMorph.
	aSentOrReceivedMessage visit: messageBrick.
		
	"position of blank space depends on message's sender"
	aSentOrReceivedMessage visit: self.	
! !

!GTMessageRowBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 12:29'!
messageBrick
	^ messageBrick! !

!GTMessageRowBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/15/2015 18:32'!
visitChatterMessage: aMessage factory: aGTCMessageFactory 
	^ aMessage acceptMessageRowBrick: self factory: aGTCMessageFactory! !

GLMBrick subclass: #GTOnlineUsersDropListBrick
	instanceVariableNames: 'dropList chatterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:56'!
chatterModel
	^ chatterModel! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:56'!
chatterModel: aGTChatter 
	chatterModel := aGTChatter.
	self dropList: self newDropList.! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:56'!
conversation
	^ self data! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:56'!
conversation: aConversation
	self data: aConversation.! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 12:57'!
dropList
	^ dropList! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 16:01'!
dropList: aBrick
	self dropList ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	dropList := aBrick.
	self theme chatterWidgetThemer dropListStyleFor: dropList.
	dropList 
		on: self
			list: #recentOnlineUsers
			selected: nil
			changeSelected: #selectedRecipient:;
		useSelectionIndex: false.
	self addBrickBack: dropList.! !

!GTOnlineUsersDropListBrick methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 1/24/2015 13:24'!
initialize
	super initialize.
	self theme chatterWidgetThemer onlineUsersStyleFor: self! !

!GTOnlineUsersDropListBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/14/2015 13:40'!
newDropList
	^ DropListMorph new! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:48'!
onlineUsers
	^ self chatterModel onlineUsers.! !

!GTOnlineUsersDropListBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:51'!
recentOnlineUsers
	^ self onlineUsers recent! !

!GTOnlineUsersDropListBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/14/2015 13:57'!
selectedRecipient: aClientId 
	self conversation ifNotNil: [ :aConversation | aConversation recipient: aClientId ]! !

!PluggableTextMorph methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/19/2015 17:44'!
chatAboutIt
	self model chatAboutSelection: self selectionInterval! !

!SmalltalkEditor class methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/15/2015 16:22'!
chatterEditorMenuOn: aBuilder
	"Specify the menu used when writing code. Try it with:
	(PragmaMenuBuilder 
		pragmaKeyword: 'smalltalkEditorMenu'
		model: nil) menu popUpInWorld
	"
	<contextMenu>
	<smalltalkEditorMenu>
	
	aBuilder
				item: 'Chat about it'; 
				selector: #chatAboutIt;
				order: 0.! !

FuelOutStackDebugAction subclass: #GTCChatAboutStackDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Integration'!

!GTCChatAboutStackDebugAction class methodsFor: 'registration' stamp: 'JurajKubelka 1/20/2015 15:27'!
actionType
	<contextMenuDebuggingAction>! !

!GTCChatAboutStackDebugAction class methodsFor: 'registration' stamp: 'JurajKubelka 1/20/2015 15:29'!
gtActionFor: aDebugger
	<gtStackDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			order: 30! !

!GTCChatAboutStackDebugAction class methodsFor: 'serialization' stamp: 'JurajKubelka 1/20/2015 15:09'!
newConfiguredSerializer
	| serializer |	
	serializer := FLSerializer newDefault.
	self encodeDebugInformationOn: serializer. 
	serializer addPostMaterializationAction: [ :materialization | 
		Smalltalk tools debugger
			openOn: Processor activeProcess 
			context: materialization root 
			label: 'External stack' 
			contents: nil 
			fullView: false ].
	^ serializer! !

!GTCChatAboutStackDebugAction class methodsFor: 'serialization' stamp: 'JurajKubelka 1/20/2015 15:08'!
serializeTestFailureContext: aContext on: aStream
	| serializer |
	
	serializer := self newConfiguredSerializer.		
	serializer
		" use the sender context, generally the current context is not interesting"
		serialize: aContext
		on: aStream! !

!GTCChatAboutStackDebugAction methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 15:22'!
defaultLabel

	^ 'Chat About This Stack'! !

!GTCChatAboutStackDebugAction methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 14:55'!
defaultOrder

	^ 124! !

!GTCChatAboutStackDebugAction methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 14:56'!
id

	^ #chatAboutStack! !

!GTCChatAboutStackDebugAction methodsFor: 'instructions' stamp: 'JurajKubelka 1/23/2015 13:11'!
send: aByteArray
	| aMessage aReceiver |
	aMessage := GTCStackTraceMessage new.
	aMessage stack: aByteArray.
	aMessage title: self debugger title.
	aReceiver := GTChatter me selectRecipient.
	aMessage to: aReceiver.
	aReceiver ifNotNil: [ 
		[ GTChatter me send: aMessage ] forkAt: Processor userBackgroundPriority ].! !

!GTCChatAboutStackDebugAction methodsFor: 'actions' stamp: 'JurajKubelka 1/20/2015 15:46'!
serializeStack
	| aByteArray |
	'Serializing stack...' displayProgressFrom: 0 to: 1 during: [ :mainBar |	
		[ aByteArray := ByteArray streamContents: [ :aStream |
				self class
					serializeTestFailureContext: self interruptedContext copyStack		
					on: aStream ] ] 
		on: Error 
		do: [:err| self inform: 'Stack fuelling failed ', String cr, err printString "and simply continue..." ].
		mainBar current: 1. 
	].
	self send: aByteArray. ! !

GLMLabelBrick subclass: #GTRecipientBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTRecipientBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 13:36'!
initialize
	super initialize.
	self theme chatterWidgetThemer recipientStyleFor: self.
! !

!GTRecipientBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 11:27'!
recipient: aClientId
	self data: aClientId.
	self text: (aClientId ifNil: [ 'new conversation' ]) asString! !

!RGMethodDefinition methodsFor: '*GT-Chatter' stamp: 'TudorGirba 1/21/2015 11:30'!
gtInspectorActionChatAboutIt
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ 
			| ring message receiver |
			ring := self copy.
			ring 
				sourceCode: self sourceCode;
				protocol: self protocol;
				stamp: self stamp.
			message := GTCSelectionInMethodMessage new.
			message 
				ring: ring.
			receiver := GTChatter me selectRecipient.
			message to: receiver.
			receiver ifNotNil: [ GTChatter me send: message ] ];
"		icon: MooseIcons mooseIcon asGrayScaleWithAlpha;
"		title: 'Chat about it'! !

!CompiledMethod methodsFor: '*GT-Chatter' stamp: 'TudorGirba 1/21/2015 11:30'!
gtInspectorActionChatAboutIt
	<gtInspectorAction>
	^ self asFullRingDefinition gtInspectorActionChatAboutIt! !

Announcement subclass: #GTCRemoteAnnouncement
	instanceVariableNames: 'from timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

GTCRemoteAnnouncement subclass: #GTCAddressedMessage
	instanceVariableNames: 'to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

!GTCAddressedMessage methodsFor: 'testing' stamp: 'JurajKubelka 1/19/2015 16:09'!
isFor: clientId 
	^ self to = clientId! !

!GTCAddressedMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 16:09'!
to
	^ to! !

!GTCAddressedMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 16:09'!
to: anObject
	
	to := anObject! !

GTCAddressedMessage subclass: #GTCSelectionInMethodMessage
	instanceVariableNames: 'ring selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

!GTCSelectionInMethodMessage methodsFor: 'converting' stamp: 'JurajKubelka 1/20/2015 13:39'!
asMessageMorph
	^ GTCSelectionInMethodMessageBrick new
			message: self;
			yourself! !

!GTCSelectionInMethodMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 16:39'!
ring
	^ ring! !

!GTCSelectionInMethodMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 16:39'!
ring: anObject
	ring := anObject! !

!GTCSelectionInMethodMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 12:31'!
ringClass
	^ self ring ringClass! !

!GTCSelectionInMethodMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 16:40'!
selection
	^ selection! !

!GTCSelectionInMethodMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 16:40'!
selection: anObject
	selection := anObject! !

GTCAddressedMessage subclass: #GTCStackTraceMessage
	instanceVariableNames: 'stack title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

!GTCStackTraceMessage methodsFor: 'converting' stamp: 'JurajKubelka 1/23/2015 12:52'!
asMessageMorph
	^ GTCStackTraceBrick new
			message: self;
			yourself! !

!GTCStackTraceMessage methodsFor: 'protocol' stamp: 'JurajKubelka 1/20/2015 16:13'!
materialize
	^ FLMaterializer materializeFromByteArray: self stack! !

!GTCStackTraceMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 11:55'!
stack
	^ stack unzipped! !

!GTCStackTraceMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 11:55'!
stack: aByteArray 
	stack := aByteArray zipped! !

!GTCStackTraceMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 13:10'!
title
	^ title! !

!GTCStackTraceMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/23/2015 13:11'!
title: aString 
	title := aString! !

GTCAddressedMessage subclass: #GTCTextMessage
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

!GTCTextMessage class methodsFor: 'instance creation' stamp: 'JurajKubelka 1/6/2015 13:44'!
to: to

	^ self new
		to: to;
		yourself! !

!GTCTextMessage methodsFor: 'converting' stamp: 'JurajKubelka 1/20/2015 10:34'!
asMessageMorph
	^ GTCTextMessageBrick new
			message: self;
			yourself! !

!GTCTextMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 16:12'!
message
	^ message! !

!GTCTextMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 16:13'!
message: anObject
	message := anObject! !

!GTCTextMessage methodsFor: 'printing' stamp: 'JurajKubelka 1/19/2015 17:23'!
printOn: aStream
	aStream print: self message! !

GTCTextMessage subclass: #GTPrivateMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

GTCRemoteAnnouncement subclass: #GTCOnlineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

!GTCRemoteAnnouncement class methodsFor: 'instance creation' stamp: 'JurajKubelka 1/6/2015 13:39'!
from: from timestamp: timestamp

	^ self new
		from: from;
		timestamp: timestamp;
		yourself! !

!GTCRemoteAnnouncement methodsFor: 'converting' stamp: 'JurajKubelka 1/20/2015 16:17'!
asReceivedMessage
	^ GTReceivedMessage new
			contents: self;
			yourself! !

!GTCRemoteAnnouncement methodsFor: 'converting' stamp: 'JurajKubelka 1/20/2015 16:16'!
asSentMessage
	^ GTSentMessage new
			contents: self;
			yourself! !

!GTCRemoteAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 14:30'!
from
	^ from! !

!GTCRemoteAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 13:39'!
from: anObject
	
	from := anObject! !

!GTCRemoteAnnouncement methodsFor: 'initialization' stamp: 'JurajKubelka 1/6/2015 13:39'!
initialize
	super initialize.
	timestamp := DateAndTime now.! !

!GTCRemoteAnnouncement methodsFor: 'testing' stamp: 'JurajKubelka 1/6/2015 13:39'!
isFrom: aClientId
	^ from = aClientId! !

!GTCRemoteAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 14:28'!
timestamp
	^ timestamp! !

!GTCRemoteAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 13:39'!
timestamp: anObject
	
	timestamp := anObject! !

!GTCRemoteAnnouncement methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 17:06'!
updateFromChatter: aGTChatter 
	self from: aGTChatter clientId.! !

GTCRemoteAnnouncement subclass: #GTCWhoIsOnline
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-RemoteAnnouncements'!

Announcement subclass: #GTInternalAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

!GTInternalAnnouncement commentStamp: 'JurajKubelka 1/19/2015 16:05' prior: 0!
Subclasses of GTInternalAnnouncement announce Chatter's model changes. They are not intented to be sent over Internet.!

GTInternalAnnouncement subclass: #GTConversationAnnouncement
	instanceVariableNames: 'conversation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

GTConversationAnnouncement subclass: #GTCRecipientChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

GTConversationAnnouncement subclass: #GTConversationAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

!GTConversationAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 12:03'!
conversation
	^ conversation! !

!GTConversationAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 12:03'!
conversation: anObject
	conversation := anObject! !

!GTConversationAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 14:17'!
recipient
	^ self conversation recipient! !

GTConversationAnnouncement subclass: #GTMessageAdded
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

!GTMessageAdded methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 12:36'!
message
	^ message! !

!GTMessageAdded methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 12:36'!
message: anObject
	message := anObject! !

!GTMessageAdded methodsFor: 'visitor' stamp: 'JurajKubelka 1/14/2015 12:19'!
visit: aVisitor
	^ aVisitor acceptMessageAdded: self! !

GTInternalAnnouncement subclass: #GTUIAnnouncement
	instanceVariableNames: 'widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

GTUIAnnouncement subclass: #GTConversationSelected
	instanceVariableNames: 'conversation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

!GTConversationSelected methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 14:56'!
conversation
	^ conversation! !

!GTConversationSelected methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 14:56'!
conversation: aConversation
	conversation := aConversation! !

!GTConversationSelected methodsFor: 'visitor' stamp: 'JurajKubelka 1/14/2015 12:17'!
visit: aVisitor
	^ aVisitor acceptConversationSelected: self! !

GTUIAnnouncement subclass: #GTSendTextMessage
	instanceVariableNames: 'conversation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-InternalAnnouncements'!

!GTSendTextMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 13:07'!
clientId
	^ conversation recipient! !

!GTSendTextMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:42'!
conversation: aGTConversation 
	conversation := aGTConversation! !

!GTSendTextMessage methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 13:07'!
message
	^ self widget text copy! !

!GTSendTextMessage methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 13:13'!
messageSent
	"Clean input field."
	"self widget text: ''"! !

!GTUIAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 15:01'!
widget
	^ widget! !

!GTUIAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 15:01'!
widget: anObject
	widget := anObject! !

!UITheme methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/24/2015 14:17'!
chatterWidgetThemer
	^ GTChatterWidgetThemer uniqueInstance! !

!AbstractNautilusUI methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/19/2015 17:42'!
chatAboutSelection: aSelection 
	| aMethod aRing aMessage aReceiver |
	aMethod := self selectedMethod.  
	aRing := aMethod asFullRingDefinition.
	aRing 
		sourceCode: aMethod sourceCode;
		protocol: aMethod protocol;
		stamp: aMethod stamp.
	aMessage := GTCSelectionInMethodMessage new.
	aMessage 
		ring: aRing;
		selection: aSelection.
	aReceiver := GTChatter me selectRecipient.
	aMessage to: aReceiver.
	aReceiver ifNotNil: [ GTChatter me send: aMessage ].! !

GLMBrickListAdaptor subclass: #GTRowBrickAdaptor
	instanceVariableNames: 'owner modelAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTRowBrickAdaptor methodsFor: 'private' stamp: 'JurajKubelka 1/15/2015 17:24'!
emptyMorph: aNilOrMorph 
	^ self owner newRowBrick! !

!GTRowBrickAdaptor methodsFor: 'initialization' stamp: 'JurajKubelka 1/15/2015 17:10'!
initialize
	super initialize.
	self morphAtLogic: [ :anInteger :aMorph | 
		self updateOrCreateNewMorph: aMorph at: anInteger ]! !

!GTRowBrickAdaptor methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 15:49'!
modelAccessor
	^ modelAccessor ! !

!GTRowBrickAdaptor methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 15:49'!
modelAccessor: anObject
	modelAccessor := anObject! !

!GTRowBrickAdaptor methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 15:18'!
owner
	^ owner! !

!GTRowBrickAdaptor methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 15:19'!
owner: anObject
	owner := anObject! !

!GTRowBrickAdaptor methodsFor: 'private' stamp: 'JurajKubelka 1/15/2015 18:31'!
updateOrCreateNewMorph: aMorph at: anInteger
	| aBrick |
	anInteger <= origin size 
		ifFalse: [ aBrick := self emptyMorph: aMorph ]
		ifTrue: [ | aModel |
			aModel := origin at: anInteger.
			aBrick := self updateOrCreateNewMorph: aMorph model: aModel ].
	^ aBrick! !

!GTRowBrickAdaptor methodsFor: 'private' stamp: 'JurajKubelka 1/15/2015 17:23'!
updateOrCreateNewMorph: aBrickOrNil model: aModel
	^ self owner perform: modelAccessor with: aBrickOrNil with: aModel! !

SugsSuggestion subclass: #GTCChatAboutItSuggestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Integration'!

!GTCChatAboutItSuggestion methodsFor: 'execution' stamp: 'JurajKubelka 1/15/2015 16:16'!
execute
	self halt.! !

!GTCChatAboutItSuggestion methodsFor: 'execution' stamp: 'JurajKubelka 1/15/2015 16:15'!
isValidForContext
	^ true! !

!GTCChatAboutItSuggestion methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 16:14'!
label
	^ 'Chat about it' translated! !

GLMFoundationBrick subclass: #GTChatterUI
	instanceVariableNames: 'chatterModel conversationsBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTChatterUI methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 17:06'!
chatterModel
	^ chatterModel ifNil: [ chatterModel := GTChatter uniqueInstance ]! !

!GTChatterUI methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 13:04'!
chatterModel: aGTChatter 
	chatterModel := aGTChatter.
	self conversationsBrick chatterModel: aGTChatter.! !

!GTChatterUI methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 11:42'!
clientId
	^ self chatterModel clientId! !

!GTChatterUI methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 11:53'!
conversationsBrick
	^ conversationsBrick ifNil: [ 
		conversationsBrick := GTConversationsAndMessagesBrick new.
		self addBrickBack: conversationsBrick.
		conversationsBrick ]! !

!GTChatterUI methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 12:34'!
initialize
	super initialize.
	self theme chatterWidgetThemer chatterStyleFor: self.
	! !

!GTChatterUI methodsFor: 'instance creation' stamp: 'JurajKubelka 1/12/2015 11:41'!
open
	^ self
		extent: 400@300;
		doLayout; 
		openInWindowLabeled: 'Conversations of ', self clientId asString.! !

!UndefinedObject methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/15/2015 18:01'!
visitChatterMessage: aMessage factory: aGTCMessageFactory 
	^ aMessage acceptUndefinedObject: self factory: aGTCMessageFactory! !

GLMInteractableBrick subclass: #GTConversationRowBrick
	instanceVariableNames: 'recipientBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-UI'!

!GTConversationRowBrick methodsFor: 'actions' stamp: 'JurajKubelka 1/7/2015 23:18'!
click: anEvent
	self announcer announce: (GTConversationSelected new 
										conversation: self data; 
										widget: self; 
										yourself).
	^ true.! !

!GTConversationRowBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 13:08'!
conversation
	^ self data! !

!GTConversationRowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/21/2015 18:33'!
conversation: aConversation
	self conversation = aConversation ifTrue: [ ^ self ].
	self conversation ifNotNil: [ :anOldConversation |
				anOldConversation announcer unsubscribe: self ].
	self data: aConversation.
	self recipientBrick recipient: aConversation recipient.
	(aConversation announcer 
				subscribe: GTCRecipientChanged 
					send: #recipientChanged:
					to: self) subscriber: self! !

!GTConversationRowBrick methodsFor: 'examples' stamp: 'JurajKubelka 1/7/2015 11:13'!
exampleConversationModel
	| message1 message2 message3 message4 conversation |
	message1 := (String loremIpsum: 100) asSentMessage.
	message2 := GTReceivedMessage new
			message: (String loremIpsum: 100);
			timestamp: DateAndTime now;
			yourself.
	message3 := (String loremIpsum: 100) asSentMessage.
	message4 := GTReceivedMessage new
			message: (String loremIpsum: 100);
			timestamp: DateAndTime now;
			yourself.
	conversation := GTConversation new.
	conversation 
		addMessage: message1;
		addMessage: message2;
		addMessage: message3;
		addMessage: message4;
		recipient: 'client2'.
	^ conversation! !

!GTConversationRowBrick methodsFor: 'examples' stamp: 'JurajKubelka 1/7/2015 12:13'!
exampleExistingConversation
	<example>
	| model brick |
	brick := self new.
	model := brick exampleConversationModel.
	brick conversation: model.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Conversation with ', model recipient asString.! !

!GTConversationRowBrick methodsFor: 'initialization' stamp: 'JurajKubelka 1/24/2015 13:34'!
initialize
	super initialize.	
	self theme chatterWidgetThemer conversationRowStyleFor: self.
	self recipientBrick: self newRecipientBrick.
! !

!GTConversationRowBrick methodsFor: 'instance creation' stamp: 'JurajKubelka 1/24/2015 13:32'!
newRecipientBrick
	^ GTRecipientBrick new! !

!GTConversationRowBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:32'!
recipientBrick
	^ recipientBrick! !

!GTConversationRowBrick methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 13:33'!
recipientBrick: aBrick
	recipientBrick ifNotNil: [ :anOldBrick | self removeBrick: anOldBrick ].
	recipientBrick := aBrick.
	self addBrickBack: aBrick.
	! !

!GTConversationRowBrick methodsFor: 'events-processing' stamp: 'JurajKubelka 1/14/2015 14:31'!
recipientChanged: aGTCRecipientChanged 
	aGTCRecipientChanged conversation = self conversation ifFalse: [ ^ self ].
	self recipientBrick recipient: aGTCRecipientChanged recipient.
	self changed.! !

!GTConversationRowBrick methodsFor: 'visitor' stamp: 'JurajKubelka 1/15/2015 18:53'!
visitChatterMessage: aGTConversation factory: aBrickFactory
	^ aGTConversation acceptConversationRowBrick: self factory: aBrickFactory! !

TestCase subclass: #GTChatterExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Tests'!

!GTChatterExamplesTest commentStamp: '<historical>' prior: 0!
A GTChatterExamplesTest is a test class for testing the behavior of GTChatterExamples!

!GTChatterExamplesTest methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 11:21'!
examples
	^ GTChatterExamples class selectors
			select: [ :symbol | symbol beginsWith: 'example' ]! !

!GTChatterExamplesTest methodsFor: 'examples' stamp: 'JurajKubelka 1/13/2015 11:22'!
testExecuteExamples
	self examples do: [ :eachSymbol | | result |
		result := (GTChatterExamples perform: eachSymbol).
		result delete. ]! !

TestCase subclass: #GTChatterTest
	instanceVariableNames: 'server client1 client2 client3 message proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Tests'!

!GTChatterTest commentStamp: '<historical>' prior: 0!
A GTChatterTest is a test class for testing the behavior of GTChatter!

!GTChatterTest methodsFor: 'running' stamp: 'JurajKubelka 1/12/2015 16:48'!
setUp
	super setUp.
	proxy := Announcer new.
	client1 := GTChatter new clientId: 'client1'; proxy: proxy; start.
	client2 := GTChatter new clientId: 'client2'; proxy: proxy; start.
	client3 := GTChatter new clientId: 'client3'; proxy: proxy; start.
	message := 'Hello World'.! !

!GTChatterTest methodsFor: 'running' stamp: 'JurajKubelka 1/12/2015 16:48'!
tearDown
	server ifNotNil: [ :s | server := nil. s stop ].
	client1 ifNotNil: [ :s | client1 := nil. s stop ].
	client2 ifNotNil: [ :s | client2 := nil. s stop ].
	client3 ifNotNil: [ :s | client3 := nil. s stop ].
	super tearDown.! !

!GTChatterTest methodsFor: 'tests' stamp: 'JurajKubelka 1/13/2015 15:14'!
testNotifyAsOnline
	client2 onlineUsers removeAll.
	self assert: client2 onlineUsers size equals: 0.
	client1 notifyAsOnline.
	self assert: client2 onlineUsers size equals: 1.! !

!GTChatterTest methodsFor: 'tests' stamp: 'JurajKubelka 1/19/2015 16:23'!
testSendTextTo
	self assert: client1 numberOfMessages equals: 0.
	self assert: client2 numberOfMessages equals: 0.
	self assert: client3 numberOfMessages equals: 0.
	self assert: client1 numberOfConversations equals: 0.
	self assert: client2 numberOfConversations equals: 0.
	self assert: client3 numberOfConversations equals: 0.

	client1 sendText: message to: client2 clientId.
	self assert: client1 numberOfMessages equals: 1.
	self assert: client2 numberOfMessages equals: 1.
	self assert: client3 numberOfMessages equals: 0.
	self assert: client1 numberOfConversations equals: 1.
	self assert: client2 numberOfConversations equals: 1.
	self assert: client3 numberOfConversations equals: 0.
	self assert: client1 conversations first recipient equals: client2 clientId.
	self assert: client2 conversations first recipient equals: client1 clientId.

	client2 sendText: message to: client1 clientId.
	self assert: client1 numberOfMessages equals: 2.
	self assert: client2 numberOfMessages equals: 2.
	self assert: client3 numberOfMessages equals: 0.
	self assert: client1 numberOfConversations equals: 1.
	self assert: client2 numberOfConversations equals: 1.
	self assert: client3 numberOfConversations equals: 0.
	self assert: client1 conversations first recipient equals: client2 clientId.
	self assert: client2 conversations first recipient equals: client1 clientId.

	client2 sendText: message to: client3 clientId.
	self assert: client1 numberOfMessages equals: 2.
	self assert: client2 numberOfMessages equals: 3.
	self assert: client3 numberOfMessages equals: 1.
	self assert: client1 numberOfConversations equals: 1.
	self assert: client2 numberOfConversations equals: 2.
	self assert: client3 numberOfConversations equals: 1.
! !

!GTChatterTest methodsFor: 'tests' stamp: 'JurajKubelka 1/19/2015 16:23'!
testSendToAnnouncements
	| receivedAnnouncements1 receivedAnnouncements2 receivedAnnouncements3 |
	receivedAnnouncements1 := OrderedCollection new.
	receivedAnnouncements2 := OrderedCollection new.
	receivedAnnouncements3 := OrderedCollection new.
	client1 announcer when: GTConversationAnnouncement do: [ :announcement | receivedAnnouncements1 addLast: announcement ].
	client2 announcer when: GTConversationAnnouncement do: [ :announcement | receivedAnnouncements2 addLast: announcement ].
	client3 announcer when: GTConversationAnnouncement do: [ :announcement | receivedAnnouncements3 addLast: announcement ].

	client1 sendText: 'message 1' to: client2 clientId.
	self assert: receivedAnnouncements1 size equals: 1.
	self assert: receivedAnnouncements2 size equals: 1.
	self assert: receivedAnnouncements3 size equals: 0.
	
	client2 sendText: 'message 2' to: client1 clientId.
	self assert: receivedAnnouncements1 size equals: 2.
	self assert: receivedAnnouncements2 size equals: 2.
	self assert: receivedAnnouncements3 size equals: 0.

	client2 sendText: 'message 3' to: client3 clientId.
	self assert: receivedAnnouncements1 size equals: 2.
	self assert: receivedAnnouncements2 size equals: 3.
	self assert: receivedAnnouncements3 size equals: 1.
! !

!GTChatterTest methodsFor: 'tests' stamp: 'JurajKubelka 1/13/2015 15:14'!
testWhoIsOnline
	client1 whoIsOnline.
	self assert: client1 onlineUsers size equals: 2.
	self assert: client2 onlineUsers size equals: 2.
	self assert: client3 onlineUsers size equals: 2.
	self assert: (client1 onlineUsers includes: 'client2').
	self assert: (client1 onlineUsers includes: 'client3').
	self assert: (client2 onlineUsers includes: 'client1').
	self assert: (client2 onlineUsers includes: 'client3').
	self assert: (client3 onlineUsers includes: 'client1').
	self assert: (client3 onlineUsers includes: 'client2').
! !

TestCase subclass: #GTChatterUITest
	instanceVariableNames: 'client1 client2 client3 ui1 proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Tests'!

!GTChatterUITest commentStamp: '<historical>' prior: 0!
A GTChatterMorphTest is a test class for testing the behavior of GTChatterMorph!

!GTChatterUITest methodsFor: 'support' stamp: 'JurajKubelka 1/19/2015 16:23'!
basicChat
	client1 sendText: 'Hello Client2!!' to: 'client2'.
	client2 sendText: 'Hello Client1!!' to: 'client1'.
	client1 sendText: 'How are you?' to: 'client2'.
	client2 sendText: 'I am fine. Thanks' to: 'client1'.
	client1 sendText: 'Hello Client3!!' to: 'client3'.! !

!GTChatterUITest methodsFor: 'running' stamp: 'JurajKubelka 1/19/2015 13:42'!
setUp
	super setUp.
	proxy := Announcer new.
	client1 := GTChatter new clientId: 'client1'; proxy: proxy; start.
	client2 := GTChatter new clientId: 'client2'; proxy: proxy; start.
	client3 := GTChatter new clientId: 'client3'; proxy: proxy; start.
! !

!GTChatterUITest methodsFor: 'running' stamp: 'JurajKubelka 1/12/2015 16:50'!
tearDown
	client1 ifNotNil: [ :s | client1 := nil. s stop ].
	client2 ifNotNil: [ :s | client2 := nil. s stop ].
	client3 ifNotNil: [ :s | client3 := nil. s stop ].
	ui1 ifNotNil: [ :ui | ui1 := nil. ui delete ].
	super tearDown.! !

!GTChatterUITest methodsFor: 'tests' stamp: 'JurajKubelka 1/12/2015 11:57'!
testOpen
	self basicChat.
	ui1 := GTChatterUI new
					chatterModel: client1;
					open.
! !

!ByteArray methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/23/2015 12:01'!
unzipped
	| magic1 magic2 |
	magic1 := (self at: 1) asInteger.
	magic2 := (self at: 2) asInteger.
	(magic1 = 16r1F and:[magic2 = 16r8B]) ifFalse:[^self].
	^(GZipReadStream on: self) upToEnd! !

!ByteArray methodsFor: '*GT-Chatter' stamp: 'JurajKubelka 1/23/2015 11:58'!
zipped
	| stream gzstream |

	stream := RWBinaryOrTextStream on: self class new.

	gzstream := GZipWriteStream on: stream.
	gzstream nextPutAll: self.
	gzstream close.
	stream reset.

	^ stream contents.
! !

Object subclass: #GTCNullConversation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

Object subclass: #GTCOnlineUsers
	instanceVariableNames: 'monitor users lastWhoIsOnlineQuestionTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTCOnlineUsers methodsFor: 'adding' stamp: 'JurajKubelka 1/13/2015 15:01'!
addOnlineUser: aGTCOnlineClient 
	^ monitor critical: [ 
		users removeAllSuchThat: [ :each | each isFrom: aGTCOnlineClient from ].
		users add: aGTCOnlineClient. ]! !

!GTCOnlineUsers methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 15:19'!
all
	"get all users"
	^ monitor critical: [ users collect: #from ]! !

!GTCOnlineUsers methodsFor: 'testing' stamp: 'JurajKubelka 1/13/2015 15:13'!
includes: aClientId 
	^ monitor critical: [ users anySatisfy: [ :each | each from = aClientId ] ]! !

!GTCOnlineUsers methodsFor: 'initialization' stamp: 'JurajKubelka 1/13/2015 14:58'!
initialize
	super initialize.
	monitor := Monitor new.
	users := OrderedCollection new.! !

!GTCOnlineUsers methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 15:25'!
onlineSince: aDateAndTime 
	^ monitor critical: [ 
		users 
			select: [ :each | each timestamp > aDateAndTime ]
			thenCollect: #from ]! !

!GTCOnlineUsers methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 15:11'!
receivedWhoIsOnline: aGTCWhoIsOnline 
	lastWhoIsOnlineQuestionTimestamp := aGTCWhoIsOnline timestamp.! !

!GTCOnlineUsers methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 15:23'!
recent
	"get recently online users"
	^ self onlineSince: self recentTimestamp! !

!GTCOnlineUsers methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 19:48'!
recentTimestamp
	^ (lastWhoIsOnlineQuestionTimestamp ifNil: [ DateAndTime now ]) - 1 minute! !

!GTCOnlineUsers methodsFor: 'removing' stamp: 'JurajKubelka 1/13/2015 15:07'!
removeAll
	"useful for test cases"
	monitor critical: [ users removeAll ]! !

!GTCOnlineUsers methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 15:02'!
size
	^ monitor critical: [ users size ]! !

Object subclass: #GTCOnlineUsersUpdater
	instanceVariableNames: 'chatter process monitor shouldContinue delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTCOnlineUsersUpdater methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 19:18'!
askWhoIsOnline
	chatter ifNotNil: [ :aChatter | aChatter whoIsOnline ]! !

!GTCOnlineUsersUpdater methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 19:19'!
chatter: aChatter
	chatter := aChatter! !

!GTCOnlineUsersUpdater methodsFor: 'initialization' stamp: 'JurajKubelka 1/13/2015 19:40'!
initialize
	super initialize.
	monitor := Monitor new.! !

!GTCOnlineUsersUpdater methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 19:41'!
start
	monitor critical: [ 
		process ifNotNil: [ :aProcess | aProcess isTerminated ifFalse: [ ^ self ] ].
		shouldContinue := true.
		delay := 1 minute asDelay.
		process := [ 
			[ shouldContinue ] whileTrue: [ 
				self askWhoIsOnline.
				delay wait ] ] fork ]! !

!GTCOnlineUsersUpdater methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 19:43'!
stop
	monitor critical: [ 
		shouldContinue := false.
		process := nil.
		delay ifNotNil: [ :aDelay | aDelay delaySemaphore signal ].
		delay := nil. ]! !

Object subclass: #GTCSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

GTCSettings class
	instanceVariableNames: 'url'!

!GTCSettings commentStamp: 'JurajKubelka 1/19/2015 13:16' prior: 0!
Global GT-Chatter settings.!

GTCSettings class
	instanceVariableNames: 'url'!

!GTCSettings class methodsFor: 'settings' stamp: 'JurajKubelka 1/19/2015 13:14'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #stringUrl)
		parent: #gt;
		target: self;
		description: 'The url for the Chatter server.' translated;
		label: 'Chatter server URL address'
! !

!GTCSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 13:11'!
stringUrl
	^ self url asString! !

!GTCSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 13:12'!
stringUrl: anUrlObject
	url := anUrlObject ifNotNil: [ anUrlObject asZnUrl ]! !

!GTCSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 13:09'!
url
	^ url ifNil: [ url := 'ws://gc.dcc.uchile.cl.:8855' asZnUrl ]! !

Object subclass: #GTChatter
	instanceVariableNames: 'announcer clientId conversations proxy filter subscribed onlineUsers onlineUsersUpdater'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

GTChatter class
	instanceVariableNames: 'uniqueInstance weakWindowHolder'!

GTChatter class
	instanceVariableNames: 'uniqueInstance weakWindowHolder'!

!GTChatter class methodsFor: 'ui' stamp: 'JurajKubelka 1/24/2015 22:12'!
close
	weakWindowHolder ifNotNil: [ :aHolder | 
			aHolder first ifNotNil: [ :aWindow | aWindow delete ] ]! !

!GTChatter class methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 14:54'!
me
	^ self uniqueInstance! !

!GTChatter class methodsFor: 'ui' stamp: 'JurajKubelka 1/24/2015 22:11'!
open
	^ self window ifNotNil: [ :aWindow | aWindow openAsIs; expand; activate; yourself ]! !

!GTChatter class methodsFor: 'ui' stamp: 'JurajKubelka 1/19/2015 14:18'!
openNamed: aClientId 
	^ self new clientId: aClientId; open! !

!GTChatter class methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 21:31'!
reset
	self close.
	uniqueInstance ifNotNil: [ :aChatter |
		uniqueInstance := nil.
		aChatter stop ]! !

!GTChatter class methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 16:23'!
sendText: aMessage to: aClientId
	^ self uniqueInstance sendText: aMessage to: aClientId! !

!GTChatter class methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 16:51'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTChatter class methodsFor: 'ui' stamp: 'JurajKubelka 1/24/2015 22:18'!
window
	weakWindowHolder ifNil: [ weakWindowHolder := WeakArray new: 1 ].
	weakWindowHolder first ifNil: [ weakWindowHolder at: 1 put: (self me open) ].
	^ weakWindowHolder first! !

!GTChatter methodsFor: 'adding' stamp: 'JurajKubelka 1/13/2015 14:57'!
addOnlineUser: aGTCOnlineClient 
	^ self onlineUsers addOnlineUser: aGTCOnlineClient! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:34'!
announcer
	^ announcer ifNil: [ 
		announcer := Announcer new.
		self subscribeForLocalAnnouncements.
		announcer ].! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 13:09'!
announcer: anObject
	self unsubscribeFromLocalAnnoucementsOn: announcer.
	announcer := anObject.
	self subscribeForLocalAnnouncements.! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 14:37'!
answerAsOnline: aGTCWhoIsOnline
	self onlineUsers receivedWhoIsOnline: aGTCWhoIsOnline.
	self notifyAsOnline.! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 13:08'!
clientId
	^ clientId ifNil: [ clientId := Author fullName ]! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 13:08'!
clientId: anObject
	clientId := anObject! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 12:18'!
conversations
	^ conversations ifNil: [ 
			conversations := GTConversations new
										announcer: self announcer;
										yourself ]! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:23'!
conversations: anObject
	conversations := anObject.
	conversations announcer: self announcer.! !

!GTChatter methodsFor: 'instance creation' stamp: 'JurajKubelka 1/21/2015 10:38'!
newRemoteProxy
	^ RAProxy new
			url: GTCSettings url;
			connectIfNotConnected;
			yourself! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 14:56'!
notifyAsOnline
	^ self proxy announce: (GTCOnlineClient new from: self clientId; yourself)! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 11:13'!
numberOfConversations
	^ self conversations numberOfConversations! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 13:57'!
numberOfMessages
	^ self conversations numberOfMessages! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 14:39'!
onlineUsers
	^ onlineUsers ifNil: [ onlineUsers := GTCOnlineUsers new ]! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 19:21'!
onlineUsersUpdater
	^ onlineUsersUpdater ifNil: [ onlineUsersUpdater := GTCOnlineUsersUpdater new chatter: self; yourself ]! !

!GTChatter methodsFor: 'ui' stamp: 'JurajKubelka 1/12/2015 17:03'!
open
	self start.
	^ GTChatterUI new
			chatterModel: self;
			open.! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/21/2015 10:39'!
proxy
	^ proxy ifNil: [ self proxy: self newRemoteProxy. proxy ]! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/19/2015 17:45'!
proxy: anObject
	| shouldSubscribe |
	shouldSubscribe := proxy notNil.
	proxy ifNotNil: [ :aProxy | self unsubscribeFromRemoteAnnoucements ].
	proxy := anObject.
	shouldSubscribe ifTrue: [ self subscribeForRemoteAnnoucements ].! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/12/2015 11:39'!
receive: aMessage 
	^ self conversations 
				receive: aMessage asReceivedMessage 
				from: aMessage from! !

!GTChatter methodsFor: 'ui' stamp: 'JurajKubelka 1/15/2015 19:48'!
selectRecipient
	| dialog recipient |
	dialog := ListDialogWindow new
		getList: [ :r | self onlineUsers recent select: [ :e | r search: e asString ] ];
		displayBlock: [ :e | e ];
		title: 'Select a user' translated;
		yourself.
	recipient := dialog chooseFromOwner: World.
	^ recipient! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 17:06'!
send: anAnnouncement
	| message |
	anAnnouncement updateFromChatter: self.
	message := self sent: anAnnouncement.
	self proxy announce: anAnnouncement.! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 16:31'!
sendText: aTextOrString to: aClientId
	| anAnnouncement |
	anAnnouncement := GTCTextMessage new 
										from: self clientId; 
										to: aClientId; 
										message: aTextOrString;
										yourself.
	self send: anAnnouncement.! !

!GTChatter methodsFor: 'private' stamp: 'JurajKubelka 1/19/2015 16:49'!
sent: aRemoteAnnouncement 
	^ self conversations sent: aRemoteAnnouncement asSentMessage! !

!GTChatter methodsFor: 'private' stamp: 'JurajKubelka 1/6/2015 14:55'!
sent: aMessage to: aClientId 
	^ self conversations 
				sent: aMessage asSentMessage 
				to: aClientId! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/12/2015 16:44'!
setLocalProxy
	"Useful for test cases."
	self proxy: Announcer new.! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/21/2015 10:39'!
setRemoteProxy
	"Useful for test cases."
	self proxy: self newRemoteProxy.! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 17:45'!
start
	self subscribeForRemoteAnnoucements.
	self notifyAsOnline.
	self onlineUsersUpdater start.! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 17:45'!
stop
	self onlineUsersUpdater stop.
	self unsubscribeFromRemoteAnnoucements.
	! !

!GTChatter methodsFor: 'private' stamp: 'JurajKubelka 1/19/2015 17:29'!
subscribeForLocalAnnouncements
	self announcer 
		when: GTSendTextMessage 
			do: [ :announcement | 
				self sendText: announcement message to: announcement clientId.
				announcement messageSent ]
			for: self.! !

!GTChatter methodsFor: 'private' stamp: 'JurajKubelka 1/19/2015 17:45'!
subscribeForRemoteAnnoucements
	self subscribed ifTrue: [ ^ self ].
	subscribed := true.
	self proxy 
		when: GTCAddressedMessage 
			do: [ :announcement | 
				(announcement isFor: self clientId) 
					ifTrue: [ self receive: announcement ] ]
			for: self;
		when: GTCOnlineClient 
			do: [ :announcement | 
				 (announcement isFrom: self clientId)
					ifFalse: [ self addOnlineUser: announcement ] ]
			for: self;
		when: GTCWhoIsOnline 
			do: [ :announcement | self answerAsOnline: announcement ]
			for: self.! !

!GTChatter methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 16:57'!
subscribed
	^ subscribed ifNil: [ subscribed := false ]! !

!GTChatter methodsFor: 'private' stamp: 'JurajKubelka 1/13/2015 12:38'!
unsubscribeFromLocalAnnoucementsOn: anAnnouncerOrNil
	anAnnouncerOrNil ifNotNil: [ anAnnouncerOrNil unsubscribe: self ]! !

!GTChatter methodsFor: 'private' stamp: 'JurajKubelka 1/19/2015 17:45'!
unsubscribeFromRemoteAnnoucements
	self proxy unsubscribe: self.
	subscribed := false.! !

!GTChatter methodsFor: 'protocol' stamp: 'JurajKubelka 1/13/2015 15:09'!
whoIsOnline
	self proxy announce: (GTCWhoIsOnline new 
									from: self clientId;
									yourself)! !

Object subclass: #GTChatterExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Examples'!

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 10:49'!
conversationModel
	| conversation random max |
	conversation := GTConversation new.
	conversation recipient: 'client2'.
	random := Random new.
	max := (random next * 100) asInteger.
	1 to: max do: [ :aNumber | | message |
		message := random next < 0.5 
							ifTrue: [ self sentMessageModel ]
							ifFalse: [ self receivedMessageModel ].
	conversation addMessage: message ].
	^ conversation! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 13:11'!
conversationsModel
	| conversations |
	conversations := GTConversations new.
	1 to: 20 do: [ :index | | conversation |
		conversation := self conversationModel.
		conversation recipient: 'client ', index asString.
		conversations addConversation: conversation ].
	^ conversations! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/19/2015 14:15'!
exampleChatterUI
	<example>
	| chatter |
	chatter := GTChatter new.
	chatter setLocalProxy.
	chatter conversations: self conversationsModel.
	^ chatter open! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'AliakseiSyrel 1/21/2015 18:08'!
exampleConversationBrick
	<example>
	| model brick |
	brick := GTConversationBrick new.
	model := self conversationModel.
	brick conversation: model.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			extent: 400@300;
			doLayout;
			openInWindowLabeled: 'My messages with ', model recipient asString.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/15/2015 18:37'!
exampleConversationsBrick
	<example>
	| model brick |
	brick := GTConversationsBrick new.
	model := GTChatter new conversations: self conversationsModel; yourself.
	brick chatterModel: model.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			extent: 400@300;
			openInWindowLabeled: 'My Conversations'.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/20/2015 12:39'!
exampleMessageInputFieldBrick
	^ GLMFoundationBrick new
			addBrickBack: GTMessageInputFieldBrick new;
			extent: 300@300;
			openInWindowLabeled: 'Message Input Field'! !

!GTChatterExamples class methodsFor: 'examples - random model' stamp: 'JurajKubelka 1/20/2015 13:24'!
exampleRandomChatterUI
	<example>
	| chatter |
	chatter := GTChatter new.
	chatter setLocalProxy.
	chatter conversations: self randomConversationsModel.
	^ chatter open! !

!GTChatterExamples class methodsFor: 'examples - random model' stamp: 'JurajKubelka 1/20/2015 14:32'!
exampleRandomConversationBrick
	<example>
	| model brick |
	brick := GTConversationBrick new.
	model := self randomConversationModel.
	brick conversation: model.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			extent: 400@300;
			openInWindowLabeled: 'My messages with ', model recipient asString.! !

!GTChatterExamples class methodsFor: 'examples - random model' stamp: 'JurajKubelka 1/20/2015 14:00'!
exampleRandomSentMessageRowBrick
	<example>
	| brick |
	brick := GTMessageRowBrick new.
	brick message: self randomSentMessageModel.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Sent Message'.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/15/2015 14:46'!
exampleReceivedMessageRowBrick
	<example>
	| brick |
	brick := GTMessageRowBrick new.
	brick message: self receivedMessageModel.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Received Message'.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/23/2015 12:10'!
exampleSelectionInMethodMessageBrick
	<example>
	| brick |
	brick := GTCSelectionInMethodMessageBrick new.
	brick message: self selectionInMethodModel.
	brick color: Color white.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Selection In Method Message'.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/15/2015 14:47'!
exampleSentMessageRowBrick
	<example>
	| brick |
	brick := GTMessageRowBrick new.
	brick message: self sentMessageModel.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Sent Message'.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/20/2015 14:25'!
exampleSentSelectionInMethodRowBrick
	<example>
	| brick |
	brick := GTMessageRowBrick new.
	brick message: self sentSelectionInMethodModel.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Sent Message'.! !

!GTChatterExamples class methodsFor: 'examples' stamp: 'JurajKubelka 1/20/2015 12:39'!
exampleTextMessageBrick
	<example>
	| brick |
	brick := GTCTextMessageBrick new.
	brick message: self messageModel.
	^ GLMFoundationBrick new
			addBrickBack: brick;
			openInWindowLabeled: 'Text Message'.! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 12:38'!
messageModel
	^ GTCTextMessage new
			message: (String loremIpsum: ((Random new next * 100) rounded) + 10);
			yourself! !

!GTChatterExamples class methodsFor: 'accessing - random model' stamp: 'JurajKubelka 1/24/2015 14:41'!
randomConversationModel
	| conversation random max |
	conversation := GTConversation new.
	conversation recipient: 'client2'.
	random := Random new.
	max := (random next * 10) asInteger + 5.
	1 to: max do: [ :aNumber | | message |
		message := random next < 0.5 
							ifTrue: [ self randomSentMessageModel ]
							ifFalse: [ self randomReceivedMessageModel ].
	conversation addMessage: message ].
	^ conversation! !

!GTChatterExamples class methodsFor: 'accessing - random model' stamp: 'JurajKubelka 1/24/2015 14:40'!
randomConversationsModel
	| conversations |
	conversations := GTConversations new.
	1 to: 13 do: [ :index | | conversation |
		conversation := self randomConversationModel.
		conversation recipient: 'client ', index asString.
		conversations addConversation: conversation ].
	^ conversations! !

!GTChatterExamples class methodsFor: 'accessing - random model' stamp: 'JurajKubelka 1/20/2015 13:20'!
randomModel
	^ self perform: ({ #messageModel. #selectionInMethodModel } atRandom)! !

!GTChatterExamples class methodsFor: 'accessing - random model' stamp: 'JurajKubelka 1/20/2015 13:21'!
randomReceivedMessageModel
	^ self randomModel asReceivedMessage! !

!GTChatterExamples class methodsFor: 'accessing - random model' stamp: 'JurajKubelka 1/20/2015 13:22'!
randomSentMessageModel
	^ self randomModel asSentMessage! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 10:31'!
receivedMessageModel
	^ self messageModel asReceivedMessage! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 14:20'!
receivedSelectionInMethodModel
	^ self selectionInMethodModel asReceivedMessage! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 13:30'!
selectionInMethodModel
	| allClasses aClass aSelector |
	allClasses := (Smalltalk globals allClassesAndTraits 
							select: [ :each | each methodDict notEmpty ]).
	aClass := allClasses atRandom.
	aSelector := aClass selectors atRandom.
	^ GTCSelectionInMethodMessage new
		ring: (aClass >> aSelector) asFullRingDefinition;
		selection: (1 to: 4);
		yourself! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 10:31'!
sentMessageModel
	^ self messageModel asSentMessage! !

!GTChatterExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 14:22'!
sentSelectionInMethodModel
	^ self selectionInMethodModel asSentMessage! !

Object subclass: #GTChatterWidgetThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Theme'!

GTChatterWidgetThemer class
	instanceVariableNames: 'instance'!

GTChatterWidgetThemer class
	instanceVariableNames: 'instance'!

!GTChatterWidgetThemer class methodsFor: 'accessing' stamp: 'JurajKubelka 1/24/2015 14:17'!
reset
	instance := nil! !

!GTChatterWidgetThemer class methodsFor: 'instance creation' stamp: 'JurajKubelka 1/24/2015 14:16'!
uniqueInstance 
	^ instance ifNil: [ instance := self new ]! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 23:06'!
backgroundColor
	"used as background color for all panes"
	^ Color white! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:02'!
borderColor
	"color that is used for border and dividers of UI parts of Spotter
	for example divider between header and results or between preview and list"
	^ Color r: 180 g: 180 b: 180 range: 255! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:02'!
buttonPressedColor

	^ self backgroundColor darker! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:11'!
buttonSelectedColor
	^ self buttonPressedColor darker! !

!GTChatterWidgetThemer methodsFor: 'styles' stamp: 'JurajKubelka 1/24/2015 15:06'!
chatterStyleFor: aBrick
	aBrick
		color: self backgroundColor! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 13:05'!
conversationHorizontalPercent
	^ 70! !

!GTChatterWidgetThemer methodsFor: 'styles - conversations' stamp: 'JurajKubelka 1/24/2015 15:14'!
conversationRowStyleFor: aBrick
	aBrick
		"to allow my children have proportional width (i.e 33% of me) and to fill my height"	
		layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new;
		enable;
		normalColor: self itemNormalBackgroundColor;
		selectedColor: self itemSelectedBackgroundColor;
		pressedColor: self itemPressedBackgroundColor;
		checkedColor: self itemCheckedBackroundColor.
		
	"here we configurate paddings"
	aBrick layoutProperties
		hSpaceFill;
		paddingLeft: 5;
		paddingRight: 5;
		paddingTop: 10;
		paddingBottom: 10.! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 19:48'!
conversationStyleFor: aBrick
	aBrick layoutPolicy: GLMBrickVerticalFillProportionalLinearLayout new.
	aBrick layoutProperties 
		vSpaceFill; 
		horizontalPercent: self conversationHorizontalPercent.! !

!GTChatterWidgetThemer methodsFor: 'styles' stamp: 'JurajKubelka 1/24/2015 12:55'!
conversationsAndMessagesStyleFor: aBrick
	aBrick layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new.
	aBrick layoutProperties 
		vSpaceFill; 
		hSpaceFill.
! !

!GTChatterWidgetThemer methodsFor: 'styles - conversations' stamp: 'JurajKubelka 1/24/2015 13:14'!
conversationsScrollListStyleFor: aBrick
	aBrick layoutProperties 
		hSpaceFill; 
		verticalPercent: 100.! !

!GTChatterWidgetThemer methodsFor: 'styles - conversations' stamp: 'JurajKubelka 1/24/2015 13:06'!
conversationsStyleFor: aBrick
	aBrick layoutPolicy: GLMBrickVerticalFillProportionalLinearLayout new.
	aBrick layoutProperties 
		vSpaceFill; 
		horizontalPercent: 100 - self conversationHorizontalPercent.
! !

!GTChatterWidgetThemer methodsFor: 'icons' stamp: 'JurajKubelka 1/24/2015 15:08'!
createConversationButtonIcon
	^ GLMUIThemeExtraIcons glamorousAdd! !

!GTChatterWidgetThemer methodsFor: 'styles - conversations' stamp: 'JurajKubelka 1/24/2015 15:10'!
createConversationButtonStyleFor: aBrick
	aBrick 
		normalImage: self createConversationButtonIcon;
		pressedColor: self buttonPressedColor ; 
		selectedColor: self buttonSelectedColor;
		enabled.
	aBrick layoutProperties 
		staticWidth: 30;
		staticHeight: 30.! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 16:03'!
dropListStyleFor: aBrick
	aBrick
		layoutProperties: GLMBrickLayoutProperties new;
		ghostText: self onlineUserGhostText.
	aBrick layoutProperties 
		vSpaceFill; 
		hSpaceFill.
! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:56'!
editorGhostText
	^ 'Write new message here'! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:14'!
itemCheckedBackroundColor
	^ self itemPressedBackgroundColor! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:13'!
itemNormalBackgroundColor
	^ Color transparent! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:13'!
itemPressedBackgroundColor
	^ self itemSelectedBackgroundColor darker! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:13'!
itemSelectedBackgroundColor
	^ self backgroundColor darker! !

!GTChatterWidgetThemer methodsFor: 'styles - message' stamp: 'JurajKubelka 1/24/2015 19:43'!
messageCommonStyleFor: aBrick
	aBrick
		shadowWidth: self shadowWidth.
	aBrick layoutProperties 
		horizontalPercent: 95;
		vShrinkWrap;
		paddingLeft: 5;
		paddingRight: 5;
		paddingTop: 5;
		paddingBottom: 5! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 13:39'!
messageRowStyleFor: aBrick
	aBrick
		"to allow my children have proportional width (i.e 33% of me) and to fill my height"	
		layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new.
		
	"here we configurate paddings"
	aBrick layoutProperties
		hSpaceFill;
		vShrinkWrap;
		paddingLeft: 5;
		paddingRight: 5;
		paddingTop: 5;
		paddingBottom: 5! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 19:49'!
messagesScrollListStyleFor: aBrick
	aBrick layoutProperties 
		verticalPercent: 100.
! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 16:02'!
onlineUserGhostText
	^ 'Select an online user'! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 13:24'!
onlineUsersStyleFor: aBrick
	aBrick layoutProperties 
		staticHeight: 30; 
		hSpaceFill.! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:05'!
outerBorderWidth
	"the width of the border around the whole spotter"
	^ 5! !

!GTChatterWidgetThemer methodsFor: 'values - message' stamp: 'JurajKubelka 1/24/2015 15:21'!
receivedMessageBackgroundColor
	^ self itemSelectedBackgroundColor darker! !

!GTChatterWidgetThemer methodsFor: 'styles - message' stamp: 'JurajKubelka 1/24/2015 15:41'!
receivedMessageCommonStyleFor: aBrick
	aBrick
		shadowColor: self shadowColor.! !

!GTChatterWidgetThemer methodsFor: 'values - message' stamp: 'JurajKubelka 1/24/2015 15:22'!
receivedMessageTextColor
	^ self textColor! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 15:32'!
receivedSourceCodePointerLabelStyleFor: aBrick
	aBrick textColor: self receivedMessageTextColor.! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 14:56'!
receivedSourceCodePointerStyleFor: aBrick
	self receivedMessageCommonStyleFor: aBrick.
	aBrick color: self receivedMessageBackgroundColor! !

!GTChatterWidgetThemer methodsFor: 'styles - text message' stamp: 'JurajKubelka 1/24/2015 14:59'!
receivedTextMessageEditingAreaStyleFor: aBrick
	aBrick
		backgroundColor: self receivedMessageBackgroundColor;
		textColor: self receivedMessageTextColor.! !

!GTChatterWidgetThemer methodsFor: 'styles - text message' stamp: 'JurajKubelka 1/24/2015 14:59'!
receivedTextMessageStyleFor: aBrick
	self receivedMessageCommonStyleFor: aBrick.! !

!GTChatterWidgetThemer methodsFor: 'styles - conversations' stamp: 'JurajKubelka 1/24/2015 13:35'!
recipientStyleFor: aBrick
	aBrick textPosition: #center.
	aBrick layoutProperties horizontalPercent: 100.! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 15:57'!
scrolledTextMorphStyleFor: aBrick
	aBrick
		layoutProperties: GLMBrickLayoutProperties new;
		beWrapped;
		withoutAdornment;
		withGhostText: self editorGhostText;
		alwaysAccept: true;
		autoAccept: false.
	aBrick layoutProperties 
		vSpaceFill; 
		hSpaceFill.
! !

!GTChatterWidgetThemer methodsFor: 'values - message' stamp: 'JurajKubelka 1/24/2015 15:21'!
sentMessageBackgroundColor
	^ self itemSelectedBackgroundColor! !

!GTChatterWidgetThemer methodsFor: 'styles - message' stamp: 'JurajKubelka 1/24/2015 15:41'!
sentMessageCommonStyleFor: aBrick
	aBrick
		shadowColor: self shadowColor.! !

!GTChatterWidgetThemer methodsFor: 'values - message' stamp: 'JurajKubelka 1/24/2015 15:22'!
sentMessageTextColor
	^ self textColor! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 15:32'!
sentSourceCodePointerLabelStyleFor: aBrick
	aBrick textColor: self sentMessageTextColor.! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 15:36'!
sentSourceCodePointerStyleFor: aBrick
	self sentMessageCommonStyleFor: aBrick.
	aBrick color: self sentMessageBackgroundColor! !

!GTChatterWidgetThemer methodsFor: 'styles - text message' stamp: 'JurajKubelka 1/24/2015 15:01'!
sentTextMessageEditingAreaStyleFor: aBrick
	aBrick
		backgroundColor: self sentMessageBackgroundColor;
		textColor: self sentMessageTextColor.! !

!GTChatterWidgetThemer methodsFor: 'styles - text message' stamp: 'JurajKubelka 1/24/2015 15:01'!
sentTextMessageStyleFor: aBrick
	self sentMessageCommonStyleFor: aBrick.! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:42'!
shadowColor
	^ self backgroundColor darker alpha: 0.2! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 19:44'!
shadowWidth
	^ 3! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 15:39'!
sourceCodePointerBrowseButtonStyleFor: aBrick
	aBrick
		enable;
		icon: GLMUIThemeExtraIcons glamorousBrowse.
	aBrick layoutProperties 
		horizontalPercent: 0;
		staticWidth: [ :brick | brick normalImage width + (2 * self outerBorderWidth) ].! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 15:37'!
sourceCodePointerLabelStyleFor: aBrick
	aBrick padding: #(5 5).
	aBrick layoutProperties hSpaceFill.! !

!GTChatterWidgetThemer methodsFor: 'styles - source code pointer' stamp: 'JurajKubelka 1/24/2015 15:35'!
sourceCodePointerStyleFor: aBrick
	self messageCommonStyleFor: aBrick.
! !

!GTChatterWidgetThemer methodsFor: 'values' stamp: 'JurajKubelka 1/24/2015 15:22'!
textColor
	^ Color black! !

!GTChatterWidgetThemer methodsFor: 'styles - text message' stamp: 'JurajKubelka 1/24/2015 13:55'!
textMessageEditingAreaStyleFor: aBrick
	aBrick
		layoutProperties: GLMBrickLayoutProperties new;
		beReadOnly;
		beWrapped.
	aBrick layoutProperties 
		hSpaceFill.! !

!GTChatterWidgetThemer methodsFor: 'styles - conversation' stamp: 'JurajKubelka 1/24/2015 16:17'!
textMessageInputFieldStyleFor: aBrick
	aBrick
		height: [ :brick | brick totalTextHeight ].
	aBrick layoutProperties 
		staticHeight: [ :brick | brick totalTextHeight ];
		hSpaceFill.
! !

!GTChatterWidgetThemer methodsFor: 'styles - text message' stamp: 'JurajKubelka 1/24/2015 15:31'!
textMessageStyleFor: aBrick
	self messageCommonStyleFor: aBrick.! !

Object subclass: #GTConversation
	instanceVariableNames: 'recipient messages announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTConversation methodsFor: 'visitor' stamp: 'JurajKubelka 1/15/2015 18:54'!
acceptConversationRowBrick: aGTConversationRowBrick factory: aFactoryBrick 
	aGTConversationRowBrick conversation: self.
	^ aGTConversationRowBrick! !

!GTConversation methodsFor: 'visitor' stamp: 'JurajKubelka 1/15/2015 18:43'!
acceptUndefinedObject: anUndefinedObject factory: aBrickFactory 
	| aBrick |
	aBrick := aBrickFactory newRowBrick.
	aBrick conversation: self.
	^ aBrick! !

!GTConversation methodsFor: 'adding' stamp: 'JurajKubelka 1/6/2015 14:40'!
addMessage: aGTMessage 
	^ self messages addLast: aGTMessage.! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:17'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:32'!
announcer: anAnnouncer 
	announcer := anAnnouncer ! !

!GTConversation methodsFor: 'converting' stamp: 'JurajKubelka 1/6/2015 22:45'!
asString
	^ self recipient asString! !

!GTConversation methodsFor: 'testing' stamp: 'JurajKubelka 1/14/2015 08:35'!
isNewConversation
	^ self messages isEmpty! !

!GTConversation methodsFor: 'testing' stamp: 'JurajKubelka 1/6/2015 16:35'!
isWith: aClientId 
	^ self recipient = aClientId! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 14:34'!
messages	
	^ messages ifNil: [ messages := OrderedCollection new ]! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 14:33'!
messages: anObject
	
	messages := anObject! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 14:48'!
numberOfMessages
	^ self messages size! !

!GTConversation methodsFor: 'printing' stamp: 'JurajKubelka 1/12/2015 14:17'!
printOn: aStream
	aStream
		print: self numberOfMessages;
		nextPutAll: ' message'.
	self numberOfMessages = 1 ifFalse: [ aStream nextPut: $s ].
	aStream
		nextPutAll: ' with ';
		print: self recipient! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/7/2015 10:13'!
recipient
	^ recipient! !

!GTConversation methodsFor: 'accessing' stamp: 'JurajKubelka 1/14/2015 14:36'!
recipient: anObject
	recipient = anObject ifTrue: [ ^ self ].
	recipient := anObject.
	self announcer announce: (GTCRecipientChanged new conversation: self; yourself)! !

!GTConversation methodsFor: 'ui' stamp: 'JurajKubelka 1/15/2015 18:40'!
updateBrick: aBrickOrNil factory: aBrickFactory 
	^ aBrickOrNil visitChatterMessage: self factory: aBrickFactory! !

Object subclass: #GTConversations
	instanceVariableNames: 'monitor items announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTConversations methodsFor: 'adding' stamp: 'JurajKubelka 1/13/2015 13:11'!
addConversation: aGTConversation 
	aGTConversation announcer: self announcer.
	monitor critical: [ items addFirst: aGTConversation ].
	self announcer announce: (GTConversationAdded new conversation: aGTConversation; yourself).
	^ aGTConversation! !

!GTConversations methodsFor: 'adding' stamp: 'JurajKubelka 1/12/2015 12:37'!
addMessage: aGTMessage to: aConversation 
	| message |
	message := aConversation addMessage: aGTMessage.
	self announcer announce: (GTMessageAdded new
											conversation: aConversation;
											message: message;
											yourself).
	^ message! !

!GTConversations methodsFor: 'adding' stamp: 'JurajKubelka 1/14/2015 11:11'!
addNewConversation
	^ self addConversation: GTConversation new.! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 12:18'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/13/2015 12:32'!
announcer: anAnnouncer
	announcer := anAnnouncer.
	self do: [ :eachConversation | eachConversation announcer: announcer ]! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/15/2015 17:38'!
at: anIndex
	^ monitor critical: [ 
		(anIndex < 1 or: [ anIndex > items size ])
			ifTrue: [ GTCNullConversation new ]
			ifFalse: [ items at: anIndex ] ]! !

!GTConversations methodsFor: 'enumerating' stamp: 'JurajKubelka 1/13/2015 12:27'!
do: aBlockClosure 
	monitor critical: [ items do: aBlockClosure ]! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 23:03'!
first
	^ self at: 1! !

!GTConversations methodsFor: 'initialization' stamp: 'JurajKubelka 1/6/2015 13:10'!
initialize
	super initialize.
	items := OrderedCollection new.
	monitor := Monitor new.! !

!GTConversations methodsFor: 'instance creation' stamp: 'JurajKubelka 1/13/2015 13:11'!
newConversationWithRecipient: aClientId message: aGTMessage
	| conversation |
	conversation := GTConversation new.
	conversation recipient: aClientId.
	conversation addMessage: aGTMessage.
	self addConversation: conversation.
	^ conversation! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/12/2015 11:14'!
numberOfConversations
	^ self size! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 13:59'!
numberOfMessages
	^ monitor critical: [ 
		items 
			ifEmpty: [ 0 ]
			ifNotEmpty: [ items sum: #numberOfMessages ] ]! !

!GTConversations methodsFor: 'printing' stamp: 'JurajKubelka 1/12/2015 14:22'!
printOn: aStream
	| numOfConversations numOfMessages |
	numOfConversations := self numberOfConversations.
	numOfMessages := self numberOfMessages.
	aStream
		print: numOfConversations;
		nextPutAll: ' conversation'.
	numOfConversations = 1
		ifFalse: [ aStream nextPut: $s ].
	aStream
		nextPutAll: ' with ';
		print: numOfMessages;
		nextPutAll: ' message'.
	numOfMessages = 1
		ifFalse: [ aStream nextPut: $s ].! !

!GTConversations methodsFor: 'protocol' stamp: 'JurajKubelka 1/12/2015 12:34'!
receive: aGTReceivedMessage from: aClientId 
	^ monitor critical: [ 
		items 
			detect: [ :aConversation | aConversation isWith: aClientId ] 
			ifFound: [ :aConversation | self addMessage: aGTReceivedMessage to: aConversation ]
			ifNone: [ self newConversationWithRecipient: aClientId message: aGTReceivedMessage ] ]! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 23:06'!
second
	^ self at: 2! !

!GTConversations methodsFor: 'protocol' stamp: 'JurajKubelka 1/19/2015 16:56'!
sent: aGTSentMessage 
	^ monitor critical: [ 
		items 
			detect: [ :aConversation | aConversation isWith: aGTSentMessage to ] 
			ifFound: [ :aConversation | self addMessage: aGTSentMessage to: aConversation ]
			ifNone: [ self newConversationWithRecipient: aGTSentMessage to message: aGTSentMessage ] ]! !

!GTConversations methodsFor: 'protocol' stamp: 'JurajKubelka 1/12/2015 12:34'!
sent: aGTSentMessage to: aClientId 
	^ monitor critical: [ 
		items 
			detect: [ :aConversation | aConversation isWith: aClientId ] 
			ifFound: [ :aConversation | self addMessage: aGTSentMessage to: aConversation ]
			ifNone: [ self newConversationWithRecipient: aClientId message: aGTSentMessage ] ]! !

!GTConversations methodsFor: 'accessing' stamp: 'JurajKubelka 1/6/2015 16:45'!
size
	^ monitor critical: [ items size ]! !

Object subclass: #GTMessageHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTMessageHolder methodsFor: 'visitor' stamp: 'JurajKubelka 1/20/2015 16:18'!
acceptMessageRowBrick: aGTMessageRowBrick factory: aGTCMessageFactory 
	aGTMessageRowBrick message: self.
	^ aGTMessageRowBrick! !

!GTMessageHolder methodsFor: 'visitor' stamp: 'JurajKubelka 1/20/2015 16:18'!
acceptUndefinedObject: anUndefinedObject factory: aGTCMessageFactory 
	| aBrick |
	aBrick := aGTCMessageFactory newMessageRowBrick.
	aBrick message: self.
	^ aBrick! !

!GTMessageHolder methodsFor: 'converting' stamp: 'JurajKubelka 1/20/2015 15:59'!
asString
	^ self contents asString! !

!GTMessageHolder methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 15:59'!
contents
	^ contents! !

!GTMessageHolder methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 15:59'!
contents: anObject
	contents := anObject! !

!GTMessageHolder methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 15:59'!
from
	^ self contents from! !

!GTMessageHolder methodsFor: 'printing' stamp: 'JurajKubelka 1/20/2015 15:59'!
printOn: aStream
	aStream nextPutAll: (contents printStringLimitedTo: 20)! !

!GTMessageHolder methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 15:59'!
timestamp
	^ self contents timestamp! !

!GTMessageHolder methodsFor: 'accessing' stamp: 'JurajKubelka 1/20/2015 15:59'!
to
	^ self contents to! !

!GTMessageHolder methodsFor: 'ui' stamp: 'JurajKubelka 1/15/2015 18:00'!
updateBrick: aBrickOrNil factory: aGTCMessageFactory 
	^ aBrickOrNil visitChatterMessage: self factory: aGTCMessageFactory! !

GTMessageHolder subclass: #GTReceivedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTReceivedMessage methodsFor: 'converting' stamp: 'JurajKubelka 1/6/2015 23:12'!
asMorph
	^ super asMorph
			color: Color lightGreen lighter;
			yourself ! !

!GTReceivedMessage methodsFor: 'printing' stamp: 'JurajKubelka 1/13/2015 13:01'!
printOn: aStream
	aStream nextPutAll: 'Received: '.
	super printOn: aStream.! !

!GTReceivedMessage methodsFor: 'visitor' stamp: 'JurajKubelka 1/7/2015 00:49'!
visit: aVisitor
	aVisitor acceptReceivedMessage: self! !

GTMessageHolder subclass: #GTSentMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Chatter-Model'!

!GTSentMessage methodsFor: 'converting' stamp: 'JurajKubelka 1/6/2015 23:14'!
asMorph
	^ super asMorph
			color: Color lightBlue lighter;
			yourself ! !

!GTSentMessage methodsFor: 'printing' stamp: 'JurajKubelka 1/13/2015 13:01'!
printOn: aStream
	aStream nextPutAll: 'Sent: '.
	super printOn: aStream.! !

!GTSentMessage methodsFor: 'visitor' stamp: 'JurajKubelka 1/7/2015 00:49'!
visit: aVisitor
	aVisitor acceptSentMessage: self! !
